vexinterrupt = {}
vexinterrupt.inParty = false
vexinterrupt.started = false
vexinterrupt.playerName = ""
vexinterrupt.AceConfigDialog = LibStub("AceConfigDialog-3.0", true)
vexinterrupt.AceConfig = LibStub("AceConfig-3.0", true)
vexinterrupt.AceConsole= LibStub("AceConsole-3.0", true)
vexinterrupt.LSM = LibStub("LibSharedMedia-3.0", true)
vexinterrupt.LSMWidgets = LibStub("AceGUI-3.0-SharedMediaWidgets", true)
vexinterrupt.scanTool = {}
vexinterrupt.options = {}

function vexinterrupt_onEvent(self, event, ...)
	if event == "PLAYER_LOGIN" then
		vexinterrupt.initialize(false)
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and vexinterrupt.started then
		if vexinterrupt_data["active"] then
			local caster = select(5, ...)
			local guid = select(4, ...)
			
			if vexinterrupt.casterCheck(guid, caster) and vexinterrupt.grpCheck() then
				local event = select(2, ...)
				if (event == "SPELL_INTERRUPT" or event == "SPELL_DISPEL" or event == "SPELL_STOLEN") and vexinterrupt_data["msg"][event][1] then
					local spellid = select(15, ...)
					local spelllink = GetSpellLink(spellid)
					local spellname = select(1, GetSpellInfo(spellid))
					local msg = vexinterrupt_data["msg"][event][2]
					
					if spelllink == nil then	spelllink = ""	end
					if spellname == nil then	spellname = ""	end
					
					msg = string.gsub(msg, "%[spelllink%]", spelllink)
					msg = string.gsub(msg, "%[spellname%]", spellname)
					
					SendChatMessage(msg, "SAY")
				end
			end
		end
	end
end

function vexinterrupt.grpCheck()
	local returnvalue = true
	local inGrp = false
	inGrp = UnitPlayerOrPetInRaid("player")
	if not(inGrp) then
		inGrp = UnitPlayerOrPetInParty("player")
	end
	if not(inGrp) and vexinterrupt_data["inGrpOnly"] then
		returnvalue = false
	end
	
	return returnvalue
end

function vexinterrupt.casterCheck(guid, caster)
	if string.find(guid, "Pet")~=nil then
		caster = vexinterrupt.getOwnerOfPet(caster)
	end
	return caster == vexinterrupt.playerName
end


function vexinterrupt.getOwnerOfPet(caster)
	vexinterrupt.scanTool.frame:ClearLines()
	vexinterrupt.scanTool.frame:SetUnit(caster)
	local ownerText = vexinterrupt.scanTool.text:GetText()
	if not ownerText then return nil end
	local owner, _ = string.split("'",ownerText)
	   
	return owner
end