function vexinterrupt.options.main()
	return {
		type = "group",
		args = {
			title={name="|CFFFF7D0AVersion: |r"..GetAddOnMetadata("vexinterrupt", "Version").."\n", type="description", order=1, fontSize="large"},
			author={name="|CFFFF7D0AAuthor: |rVexar Aegwynn-EU\n", type="description", order=2, fontSize="large"},
			slashcmds={name="\n\nSlash Cmds:\n/vexinterrupt\n/vexi", type="description", order=3, fontSize="large"},
			space={name="\n\n", type="description", order=4, fontSize="large"},
			
			
			activate = {
				name = "Enable Addon",
				order=5, type = "toggle", width="double",
				set = function(self,key) vexinterrupt_data["active"]=key end,
				get = function() return vexinterrupt_data["active"] end,
				},
				
			defaults = {
				name = "Reset to defaults",
				order=6, type = "execute",
				func = function(info,val) vexinterrupt_data = vexalarm.initialize.checkTableData(vexinterrupt.defaults, vexinterrupt_data, true) end,
				},
			}
		}
end

function vexinterrupt.options.settings()
	return {
		type = "group",
		args = {
			activate = {
				name = "Only active in a grp/raid",
				order=1, type = "toggle", width="double",
				set = function(self,key) vexinterrupt_data["inGrpOnly"]=key end,
				get = function() return vexinterrupt_data["inGrpOnly"] end,
				},
						
			interrupts = {
				name = "Interrupts",
				order=11, type ="group", dialogInline = true,
				args = {
					activate = {
						name = "Activate Output",
						order=1, type = "toggle", width="double",
						set = function(self,key) vexinterrupt_data["msg"]["SPELL_INTERRUPT"][1]=key end,
						get = function() return vexinterrupt_data["msg"]["SPELL_INTERRUPT"][1] end,
						},
					interrupt = {
						name = "Interrupt message",
						order=2, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexinterrupt_data["msg"]["SPELL_INTERRUPT"][2]=val end,
						get = function() return vexinterrupt_data["msg"]["SPELL_INTERRUPT"][2] end
						},
					interruptdefault = {
						name = "reset to defaults",
						order=3, type = "execute",
						func = function(info,val) vexinterrupt_data["msg"]["SPELL_INTERRUPT"][2]=vexinterrupt.defaults["msg"]["SPELL_INTERRUPT"][2] end,
						},
					info = {name = "You can use [spelllink] and [spellname] to parse the spell as a link or just the name into the message", type = "description", order=10,fontSize="small",},
					},
				},
			interruptspace = {name = " ", type = "description", order=12,fontSize="medium",},
			dispell = {
				name = "Dispells",
				order=20, type ="group", dialogInline = true,
				args = {
					activate = {
						name = "Activate Output",
						order=1, type = "toggle", width="double",
						set = function(self,key) vexinterrupt_data["msg"]["SPELL_DISPEL"][1]=key end,
						get = function() return vexinterrupt_data["msg"]["SPELL_DISPEL"][1] end,
						},
					interrupt = {
						name = "Dispell message",
						order=2, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexinterrupt_data["msg"]["SPELL_DISPEL"][2]=val end,
						get = function() return vexinterrupt_data["msg"]["SPELL_DISPEL"][2] end
						},
					interruptdefault = {
						name = "reset to defaults",
						order=3, type = "execute",
						func = function(info,val) vexinterrupt_data["msg"]["SPELL_DISPEL"][2]=vexinterrupt.defaults["msg"]["SPELL_DISPEL"][2] end,
						},
					info = {name = "You can use [spelllink] and [spellname] to parse the spell as a link or just the name into the message", type = "description", order=10,fontSize="small",},
					},
				},
			dispellspace = {name = " ", type = "description", order=21,fontSize="medium",},
			spellsteals = {
				name = "Spellsteal",
				order=30, type ="group", dialogInline = true,
				args = {
					activate = {
						name = "Activate Output",
						order=1, type = "toggle", width="double",
						set = function(self,key) vexinterrupt_data["msg"]["SPELL_STOLEN"][1]=key end,
						get = function() return vexinterrupt_data["msg"]["SPELL_STOLEN"][1] end,
						},
					interrupt = {
						name = "Spellsteal message",
						order=2, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexinterrupt_data["msg"]["SPELL_STOLEN"][2]=val end,
						get = function() return vexinterrupt_data["msg"]["SPELL_STOLEN"][2] end
						},
					interruptdefault = {
						name = "reset to defaults",
						order=3, type = "execute",
						func = function(info,val) vexinterrupt_data["msg"]["SPELL_STOLEN"][2]=vexinterrupt.defaults["msg"]["SPELL_STOLEN"][2] end,
						},
					info = {name = "You can use [spelllink] and [spellname] to parse the spell as a link or just the name into the message", type = "description", order=10,fontSize="small",},
					},
				},
			},
		}
end